(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_index ctx ppf = function
  | u_i -> Umatrix_nonempty_set_print.printer_index ctx ppf u_i

and printer_uindex ctx ppf = function
  | u_u -> Umatrix_nonempty_set_print.printer_uindex ctx ppf u_u
;;

let printer_domain ctx ppf = function
  | u_t -> Umatrix_nonempty_set_print.printer_t ctx ppf u_t
;;

let printer_sub_domain ctx ppf = function
  | u_n -> Umatrix_nonempty_set_print.printer_nonempty_subset ctx ppf u_n
;;

let printer_images pp_a ctx ppf = function
  | Umatrix_graph.Constant a ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Constant";
    pp_a Og_precedence.Ck_argument ppf a; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
  | Umatrix_graph.Images a_a ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Images";
    Og_printer.printer_Array pp_a Og_precedence.Ck_argument ppf a_a;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_t pp_a ctx ppf = function
  | { Umatrix_graph.domain = d; Umatrix_graph.images = a_i; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>domain =";
    printer_domain Og_precedence.Ck_record_field ppf d;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>images =";
    printer_images pp_a Og_precedence.Ck_record_field ppf a_i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

(* Defining top printers. *)

let print_index ppf = printer_index Og_precedence.Ck_toplevel ppf

and print_uindex ppf = printer_uindex Og_precedence.Ck_toplevel ppf
;;

let print_domain ppf = printer_domain Og_precedence.Ck_toplevel ppf
;;

let print_sub_domain ppf = printer_sub_domain Og_precedence.Ck_toplevel ppf
;;

let print_images pp_a ppf = printer_images pp_a Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
