(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: umatrix_universe.ml,v 1.8 2017/05/31 16:38:13 fclement Exp $*)

(* Numbering matrix slots. *)

module Hashtbl = Umatrix_hashtbl;;

type size = Hashtbl.size;;
type element = Hashtbl.key;;
type index = Hashtbl.value;;

type t =
  {
   tables : Hashtbl.t;
   cardinal : Upervasives.length;
  }
;;

(* Construction function. *)

let make sz =
  let mh = Hashtbl.make sz in
  { tables = mh; cardinal = Hashtbl.length mh; }
;;

(* Access functions. *)

let cardinal mu = mu.cardinal;;

let size mu = Hashtbl.size mu.tables;;

let index mu = Hashtbl.value_of_key mu.tables;;

let element mu = Hashtbl.key_of_value mu.tables;;

let sub_elements mu = Array.map (element mu);;
