(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: codomain.mli,v 1.12 2017/05/31 16:38:14 fclement Exp $ *)

open Segmentation_spec;;

module Make : CODOMAIN_MAKER;;

val single : (module CODOMAIN);;
val triple : (module CODOMAIN);;

val vector_of_nat : Unatural.t -> (module CODOMAIN);;

(**/**)

(* For testing purposes only. *)

module Single_Codomain : CODOMAIN with type 'a t = 'a;;
module Triple_Codomain : CODOMAIN with type 'a t = 'a * 'a * 'a;;
module Vector_Codomain :
  functor (V : Vector_spec.VECTOR) ->
  CODOMAIN with type 'a t = 'a V.t
;;
