(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: history_types.mli,v 1.11 2017/05/31 16:38:15 fclement Exp $ *)

(* Start mode. *)

type start_mode =
  | Cold_start
  | Warm_start
;;

type history_file_name = Ufilename.t;;

type write_directory_name = Ufilename.t;;

(* History mode. *)

type history_step_mode =
  | Last
  | Full
;;

type base_name = Ufilename.t;;

type checkpointing = base_name option;;

type history_mode = history_step_mode * checkpointing

(* History. *)

type state_number = Unatural.t

type 'a h_state =
  {
   state_number : state_number;
   state : 'a;
  }
;;

type 'a h_list = 'a h_state Ulist1.list1;;

type ('a, 'b) t =
  {
   configuration : 'a;
   h_mode : history_mode;
   h_list : 'b h_list;
  }
;;
