(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_arrow_number ctx ppf = function
  | u_a -> Udynamic_graph_print_xml.printer_xml_arrow_number ctx ppf u_a
;;

let printer_xml_delayed_image px_b ctx ppf = function
  | Udelayed_dgraph_types.Not_yet_computed ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,";
    Format.fprintf ppf "%,Not_yet_computed";
    Format.fprintf ppf "%,@;<0 -2></lident>@]";
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
  | Udelayed_dgraph_types.Image b ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Image";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    px_b Og_precedence.Ck_argument ppf b;
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
;;

let printer_xml_delayed_arrow px_a px_b ctx ppf = function
  | a_b_d_u_a ->
    Udynamic_graph_print_xml.printer_xml_arrow
      px_a
      (printer_xml_delayed_image px_b)
      ctx
      ppf
      a_b_d_u_a
;;

let rec printer_xml_t px_a px_b px_c ctx ppf = function
  | {
      Udelayed_dgraph_types.f = f_c_f_a_f_a_b;
      Udelayed_dgraph_types.graph = a_b_d_u_t;
      Udelayed_dgraph_types.to_do = a_l;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><f>@,";
    Og_printer_xml.printer_xml_Fun
      px_c
      (Og_printer_xml.printer_xml_Fun
         printer_xml_arrow_number
         (Og_printer_xml.printer_xml_Fun px_a px_b))
      Og_precedence.Ck_record_field
      ppf
      f_c_f_a_f_a_b;
    Format.fprintf ppf "%,@;<0 -2></f>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><graph>@,";
    Udynamic_graph_print_xml.printer_xml_t
      px_a
      (printer_xml_delayed_image px_b)
      Og_precedence.Ck_record_field
      ppf
      a_b_d_u_t;
    Format.fprintf ppf "%,@;<0 -2></graph>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><to_do>@,";
    Og_printer_xml.printer_xml_List printer_xml_arrow_number
      Og_precedence.Ck_record_field
      ppf
      a_l;
    Format.fprintf ppf "%,@;<0 -2></to_do>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"

and printer_xml_delayed_dgraph px_a px_b px_c ctx ppf = function
  | a_b_c_t -> printer_xml_t px_a px_b px_c ctx ppf a_b_c_t
;;

(* Defining top printers. *)

let print_xml_arrow_number ppf =
  printer_xml_arrow_number Og_precedence.Ck_toplevel ppf
;;

let print_xml_delayed_image px_b ppf =
  printer_xml_delayed_image px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_delayed_arrow px_a px_b ppf =
  printer_xml_delayed_arrow px_a px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a px_b px_c ppf =
  printer_xml_t px_a px_b px_c Og_precedence.Ck_toplevel ppf

and print_xml_delayed_dgraph px_a px_b px_c ppf =
  printer_xml_delayed_dgraph px_a px_b px_c Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
