(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_index ctx ppf = function
  | u_t -> Unatural_print_xml.printer_xml_t ctx ppf u_t
;;

let printer_xml_length ctx ppf = function
  | u_t -> Unatural_print_xml.printer_xml_t ctx ppf u_t
;;

let rec printer_xml_t px_a ctx ppf = function
  | { Udynamic_array.array = a_a; Udynamic_array.default = a; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><array>@,";
    Og_printer_xml.printer_xml_Array px_a
      Og_precedence.Ck_record_field
      ppf
      a_a;
    Format.fprintf ppf "%,@;<0 -2></array>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><default>@,";
    px_a Og_precedence.Ck_record_field ppf a;
    Format.fprintf ppf "%,@;<0 -2></default>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"

and printer_xml_dynamic_array px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_xml_index ppf = printer_xml_index Og_precedence.Ck_toplevel ppf
;;

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_dynamic_array px_a ppf =
  printer_xml_dynamic_array px_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
