(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_index pp_a ctx ppf = function
  | a_u_i -> Ugraph_types_print.printer_index pp_a ctx ppf a_u_i

and printer_uindex pp_a ctx ppf = function
  | a_u_u -> Ugraph_types_print.printer_uindex pp_a ctx ppf a_u_u
;;

let printer_domain pp_a ctx ppf = function
  | a_u_d -> Ugraph_types_print.printer_domain pp_a ctx ppf a_u_d

and printer_sub_domain pp_a ctx ppf = function
  | a_u_n -> Unonempty_set_print.printer_nonempty_subset pp_a ctx ppf a_u_n
;;

let printer_images pp_b ctx ppf = function
  | b_u_i -> Ugraph_types_print.printer_images pp_b ctx ppf b_u_i
;;

let rec printer_t pp_a pp_b ctx ppf = function
  | a_b_u_t -> Ugraph_types_print.printer_t pp_a pp_b ctx ppf a_b_u_t

and printer_graph pp_a pp_b ctx ppf = function
  | a_b_t -> printer_t pp_a pp_b ctx ppf a_b_t
;;

(* Defining top printers. *)

let print_index pp_a ppf = printer_index pp_a Og_precedence.Ck_toplevel ppf

and print_uindex pp_a ppf = printer_uindex pp_a Og_precedence.Ck_toplevel ppf
;;

let print_domain pp_a ppf = printer_domain pp_a Og_precedence.Ck_toplevel ppf

and print_sub_domain pp_a ppf =
  printer_sub_domain pp_a Og_precedence.Ck_toplevel ppf
;;

let print_images pp_b ppf = printer_images pp_b Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a pp_b ppf = printer_t pp_a pp_b Og_precedence.Ck_toplevel ppf

and print_graph pp_a pp_b ppf =
  printer_graph pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
