(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_uindex pp_a ctx ppf = function
  | a_u_i -> Uuniverse_print.printer_index pp_a ctx ppf a_u_i
;;

let printer_index pp_a ctx ppf = function
  | a_u_u -> printer_uindex (printer_uindex pp_a) ctx ppf a_u_u
;;

let rec printer_t pp_a ctx ppf = function
  | {
      Unonempty_set_types.universe = a_u_t;
      Unonempty_set_types.uindices = a_u_u_t;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>universe =";
    Uuniverse_print.printer_t pp_a Og_precedence.Ck_record_field ppf a_u_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>uindices =";
    Uuniverse_print.printer_t (printer_uindex pp_a)
      Og_precedence.Ck_record_field
      ppf
      a_u_u_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_nonempty_set pp_a ctx ppf = function
  | a_t -> printer_t pp_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_uindex pp_a ppf = printer_uindex pp_a Og_precedence.Ck_toplevel ppf
;;

let print_index pp_a ppf = printer_index pp_a Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf

and print_nonempty_set pp_a ppf =
  printer_nonempty_set pp_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
