(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_uindex px_a ctx ppf = function
  | a_u_u -> Unonempty_set_print_xml.printer_xml_uindex px_a ctx ppf a_u_u

and printer_xml_index px_a ctx ppf = function
  | a_u_i -> Unonempty_set_print_xml.printer_xml_index px_a ctx ppf a_u_i
;;

let rec printer_xml_t px_a ctx ppf = function
  | Uset.Empty ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Empty";
    Format.fprintf ppf "%,@;<0 -2></lident>@]";
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
  | Uset.Nonempty a_u_t ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,";
    Format.fprintf ppf "%,Nonempty";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    Unonempty_set_print_xml.printer_xml_t px_a
      Og_precedence.Ck_argument
      ppf
      a_u_t;
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"

and printer_xml_set px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

let printer_xml_subset px_a ctx ppf = function
  | { Uset.support = a_t; Uset.indices = a_i_a; Uset.set = a_t0; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><support>@,";
    printer_xml_t px_a Og_precedence.Ck_record_field ppf a_t;
    Format.fprintf ppf "%,@;<0 -2></support>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><indices>@,";
    Og_printer_xml.printer_xml_Array (printer_xml_index px_a)
      Og_precedence.Ck_record_field
      ppf
      a_i_a;
    Format.fprintf ppf "%,@;<0 -2></indices>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><set>@,";
    printer_xml_t px_a Og_precedence.Ck_record_field ppf a_t0;
    Format.fprintf ppf "%,@;<0 -2></set>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let printer_xml_dichotomy px_a ctx ppf = function
  | (a_s, a_s0) ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><tuple>@,";
    printer_xml_subset px_a Og_precedence.Ck_tuple_item ppf a_s;
    Format.fprintf ppf "%,@,";
    printer_xml_subset px_a Og_precedence.Ck_tuple_item ppf a_s0;
    Format.fprintf ppf "%,@;<0 -2></tuple>@]"
;;

(* Defining top printers. *)

let print_xml_uindex px_a ppf =
  printer_xml_uindex px_a Og_precedence.Ck_toplevel ppf

and print_xml_index px_a ppf =
  printer_xml_index px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_set px_a ppf =
  printer_xml_set px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_subset px_a ppf =
  printer_xml_subset px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_dichotomy px_a ppf =
  printer_xml_dichotomy px_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
