(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_t ctx ppf = function | s -> Og_printer.printer_String ctx ppf s
;;

let printer_length ctx ppf = function
  | u_l -> Upervasives_print.printer_length ctx ppf u_l

and printer_index ctx ppf = function
  | u_i -> Upervasives_print.printer_index ctx ppf u_i

and printer_offset ctx ppf = function
  | u_o -> Upervasives_print.printer_offset ctx ppf u_o
;;

let printer_escape_char ctx ppf = function
  | c -> Og_printer.printer_Char ctx ppf c

and printer_escaped_chars ctx ppf = function
  | c_l -> Og_printer.printer_List Og_printer.printer_Char ctx ppf c_l
;;

let printer_prefix ctx ppf = function | t -> printer_t ctx ppf t

and printer_suffix ctx ppf = function | t -> printer_t ctx ppf t
;;

(* Defining top printers. *)

let print_t ppf = printer_t Og_precedence.Ck_toplevel ppf
;;

let print_length ppf = printer_length Og_precedence.Ck_toplevel ppf

and print_index ppf = printer_index Og_precedence.Ck_toplevel ppf

and print_offset ppf = printer_offset Og_precedence.Ck_toplevel ppf
;;

let print_escape_char ppf = printer_escape_char Og_precedence.Ck_toplevel ppf

and print_escaped_chars ppf =
  printer_escaped_chars Og_precedence.Ck_toplevel ppf
;;

let print_prefix ppf = printer_prefix Og_precedence.Ck_toplevel ppf

and print_suffix ppf = printer_suffix Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
