(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_length ctx ppf = function
  | u_l -> Usubarray_types_print.printer_length ctx ppf u_l

and printer_index ctx ppf = function
  | u_i -> Usubarray_types_print.printer_index ctx ppf u_i

and printer_offset ctx ppf = function
  | u_o -> Usubarray_types_print.printer_offset ctx ppf u_o

and printer_range ctx ppf = function
  | u_r -> Usubarray_types_print.printer_range ctx ppf u_r

and printer_indices ctx ppf = function
  | u_i -> Usubarray_types_print.printer_indices ctx ppf u_i

and printer_t pp_a ctx ppf = function
  | a_u_t -> Usubarray_types_print.printer_t pp_a ctx ppf a_u_t

and printer_subarray pp_a ctx ppf = function
  | a_t -> printer_t pp_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_length ppf = printer_length Og_precedence.Ck_toplevel ppf

and print_index ppf = printer_index Og_precedence.Ck_toplevel ppf

and print_offset ppf = printer_offset Og_precedence.Ck_toplevel ppf

and print_range ppf = printer_range Og_precedence.Ck_toplevel ppf

and print_indices ppf = printer_indices Og_precedence.Ck_toplevel ppf

and print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf

and print_subarray pp_a ppf =
  printer_subarray pp_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
