(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uarray2_with_c_layout.ml,v 1.15 2017/05/31 15:24:06 fclement Exp $ *)

(* More operations on two-dimensional bigarrays with C layout. *)

open Bigarray;;

let dim1 = Array2.dim1
and dim2 = Array2.dim2
and get = Array2.get
;;

(* Iterators. *)

let iter f a =
  let ni = dim1 a in
  let nj = dim2 a in
  for i = 0 to ni - 1 do
    for j = 0 to nj - 1 do
      f (get a i j)
    done;
  done;;

let iter_ij f a =
  let ni = dim1 a in
  let nj = dim2 a in
  for i = 0 to ni - 1 do
    for j = 0 to nj - 1 do
      f i j (get a i j)
    done;
  done;;
