(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: ufilename.ml,v 1.12 2017/05/31 15:24:06 fclement Exp $ *)

module F = Filename;;

module Nat = Unatural;;
module L = Ulist;;
module S = Ustring;;

let _0_ = Nat._0_;;

type t = string
and filename = t
;;

let flatten = L.fold_left F.concat "";;

let chop_extension name =
  try
    let base = F.basename name in
    let pos = S.rindex base '.' in
    let dir = F.dirname name in
    if dir = "." then S.sub base _0_ pos else
    F.concat dir (S.sub base _0_ pos)
  with
  | Not_found -> name
;;
