(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: usubarray_types.mli,v 1.14 2017/05/31 15:24:06 fclement Exp $ *)

(** {3 The private type of subarrays} *)

type length = Uarray.length
and index = Uarray.index
and offset = Uarray.offset
;;

type range =
  {
   offset : offset;
   length : length;
  }
;;

type indices =
  | Range of range
  | Indices of index array
;;

type 'a t = private
  {
   support : 'a array;
   indices : indices;
  }
and 'a subarray = 'a t
;;

val range : 'a array -> range -> 'a t;;
val indices : 'a array -> index array -> 'a t;;
